%define rname racc


Summary: LALR(1) Parser Generator
Name: ruby-%{rname}
Version: 1.4.5
Release: 9%{?dist}
URL: http://i.loveruby.net/en/racc.html
Source0: http://i.loveruby.net/archive/racc/%{rname}-%{version}-all.tar.gz
# String#map no longer exists on ruby 1.9
Patch0:	  ruby-racc-1.4.5-map.patch
License: LGPLv2
Group: Development/Tools
BuildRoot: %{_tmppath}/%{name}-%{version}-%{release}-root-%(%{__id_u} -n)
Requires: ruby(abi) = 1.9.1
BuildRequires: ruby
BuildRequires: ruby(abi) = 1.9.1
BuildRequires: ruby-devel
Provides: ruby(racc) = 1.4.5
BuildArch: noarch 

%description
Racc is Ruby yACC. It is written in Ruby and generates ruby code.
Now almost all functions of yacc are implemented.

%prep
%setup -q -n %{rname}-%{version}-all 
pushd packages/racc
%patch0 -p1
popd

%build
ruby setup.rb config --bin-dir=%{_bindir} --rb-dir=%{ruby_vendorlibdir} --with=racc
ruby setup.rb setup

%install
rm -rf %buildroot
ruby setup.rb install --prefix=%buildroot

%check
cd packages/racc/test
ruby test.rb

%clean
rm -rf %buildroot

%files
%defattr(-,root,root)
%{ruby_vendorlibdir}/racc
%{_bindir}/racc
%{_bindir}/racc2y
%{_bindir}/y2racc
%doc packages/racc/COPYING README.* packages/racc/NEWS.* packages/racc/doc.*

%changelog
* Tue Jan 24 2012 Mamoru Tasaka <mtasaka@fedoraproject.org> - 1.4.5-9
- Change String#map to str.lines.map (in ruby 1.9) in racc

* Tue Jan 24 2012 Mamoru Tasaka <mtasaka@fedoraproject.org> - 1.4.5-8
- Rebuild against ruby 19

* Sat Jan 14 2012 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 1.4.5-7
- Rebuilt for https://fedoraproject.org/wiki/Fedora_17_Mass_Rebuild

* Wed Feb 09 2011 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 1.4.5-6
- Rebuilt for https://fedoraproject.org/wiki/Fedora_15_Mass_Rebuild

* Sun Jul 26 2009 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 1.4.5-5
- Rebuilt for https://fedoraproject.org/wiki/Fedora_12_Mass_Rebuild

* Wed Feb 25 2009 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 1.4.5-4
- Rebuilt for https://fedoraproject.org/wiki/Fedora_11_Mass_Rebuild

* Wed Sep  3 2008 Tom "spot" Callaway <tcallawa@redhat.com> - 1.4.5-3
- fix license tag

* Fri Aug 11 2006 David Lutterkort <dlutter@redhat.com> - 1.4.5-2
- Brought in accordance with packaging guidelines
- Add %%check to run the tests

* Mon Feb  6 2006 David Lutterkort <dlutter@redhat.com> - 1.4.5-1
- Adapted for Fedora

* Sun Nov 21 2005 Pascal Terjan <pterjan@mandriva.org> 1.4.5-1mdk
- 1.4.5
- mkrel

* Sun Apr 17 2005 Pascal Terjan <pterjan@mandrake.org> 1.4.4-3mdk
- fix lib64

* Fri Oct 22 2004 Pascal Terjan <pterjan@mandrake.org> 1.4.4-2mdk
- rebuild

* Thu Dec 25 2003 Pascal Terjan <CMoi@tuxfamily.org> 1.4.4-1mdk 
- first mdk release
